#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++

class Correo < ActionMailer::Base

  # FROM = "gong.development@gmail.com"

  # es llamado por EstadoController::cambio_estado para generar el mail de notificación
  def cambio_estado(usuario, tipo, proyecto_financiacion, estado)
    recipients usuario.correoe
    from 'no-reply@' + (ENV['GOR_SITEID'] || 'gong.org.es')
    subject proyecto_financiacion.nombre + ": " + _("Cambio de estado") if tipo == "proyectos"
    subject "Cambio de estado de la financiacion: " + proyecto_financiacion.nombre if tipo == "financiaciones"
    body   :usuario => usuario, :proyecto_financiacion => proyecto_financiacion, :estado => estado, :tipo => tipo
  end

  def cambio_tarea(usuario, tipo, proyecto_financiacion, tarea)
    recipients usuario.correoe
    from 'no-reply@' + (ENV['GOR_SITEID'] || 'gong.org.es')
    subject proyecto_financiacion.nombre + ": " + _("Notificación de tarea") if tipo == "proyectos"
    subject "Cambio en la tarea de la financiación: " + proyecto_financiacion.nombre if tipo == "financiaciones"
    body   :usuario => usuario, :proyecto_financiacion => proyecto_financiacion, :tarea => tarea, :tipo => tipo
  end

  def cambio_comentario(usuario, tipo, proyecto_financiacion, objeto, tarea)
    recipients usuario.correoe
    from 'no-reply@' + (ENV['GOR_SITEID'] || 'gong.org.es')
    subject proyecto_financiacion.nombre + ": " + _("Notificación de tarea") if tipo == "proyectos"
    subject "Cambio en la tarea de la financiación: " + proyecto_financiacion.nombre if tipo == "financiaciones"
    body   :usuario => usuario, :proyecto_financiacion => proyecto_financiacion, :tarea => tarea, :tipo => tipo
  end

  def asignar_usuario(usuario, usuario_asignado, rol, objeto)
    recipients usuario.correoe
    from 'no-reply@' + (ENV['GOR_SITEID'] || 'gong.org.es')
    subject _("Asignación") + " " + _("al") + " " + _(objeto.class.name.capitalize) + ": " + objeto.nombre 
    body   :usuario_asignado => usuario_asignado, :rol => rol, :objeto => objeto
  end
end
