#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# estado

class Estado < ActiveRecord::Base
  untranslate_all
  belongs_to :definicion_estado
  belongs_to :proyecto
  belongs_to :financiacion
  belongs_to :usuario

  # Comprobamos cambio de estado en proyectos
  after_save :verificar_cierre_proyecto

  private

	# Comprueba si es un cierre del proyecto
    def verificar_cierre_proyecto
      # Si es el estado actual y es cerrado...
      if self.estado_actual && self.definicion_estado.cerrado
        # Para pacs, aplica remanentes sobre el pac siguiente
        self.proyecto.pac_siguiente.aplica_remanentes if self.proyecto.pac_siguiente
      end
    end

end
