class AddLibroToPago < ActiveRecord::Migration
  def self.up
    add_column :pago, :libro_id, :integer
    add_column :pago, :observaciones, :string
    add_column :gasto, :agente_id, :integer
    # Recargamos la info de las clases
    Pago.reset_column_information
    Gasto.reset_column_information
    # Copia las cuentas a los pagos que haya
    Gasto.all.each do |gasto|
      libro = Libro.find_by_id(gasto.libro_id)
      gasto.agente_id = libro.agente_id if libro
      gasto.save
      gasto.pago.each do |pago|
        pago.libro_id = gasto.libro_id
        pago.save
      end 
    end
    remove_column :gasto, :libro_id
  end

  def self.down
    add_column :gasto, :libro_id, :integer
    # Recargamos la info de la clase
    Gasto.reset_column_information
    # Copia las cuentas a los gastos que haya
    Pago.all.each do |pago|
      pago.gasto.libro_id = pago.libro_id
      pago.gasto.save
    end
    remove_column :pago, :libro_id
    remove_column :pago, :observaciones
    remove_column :gasto, :agente_id
  end
end
