class ChangePorcentajeToImporteOnGastoXProyecto < ActiveRecord::Migration
  def self.up
    add_column :gasto_x_proyecto, :importe, :decimal, :precision => 24, :scale => 2, :default => 0.0
    # Recargamos la info de la clase
    GastoXProyecto.reset_column_information
    GastoXProyecto.all.each do |gxp|
      gxp.importe = gxp.gasto.importe * (gxp.porcentaje ? gxp.porcentaje : 1) if gxp.gasto
      gxp.save
    end
    remove_column :gasto_x_proyecto, :porcentaje
  end

  def self.down
    add_column :gasto_x_proyecto, :porcentaje, :decimal, :precision => 5, :scale => 4
    # Recargamos la info de la clase
    GastoXProyecto.reset_column_information
    GastoXProyecto.all.each do |gxp|
      gxp.porcentaje = gxp.importe / gxp.gasto.importe if gxp.gasto
      gxp.save
    end
    remove_column :gasto_x_proyecto, :importe 
  end
end
