class AddFuenteVerificacionGastos < ActiveRecord::Migration
  def self.up
    add_column :espacio, :fuente_verificacion, :boolean
    add_column :espacio, :gasto, :boolean
    Espacio.reset_column_information
    # Solo creamos los nuevos espacios si hay algun proyecto (en caso contrario suponemos que aun no hemos pasado el seeds y lo dejamos a este)
    if Proyecto.count > 0
      espacio_gasto =  Espacio.create :nombre => "Gastos", :definicion_espacio_proyecto => true, :gasto => true
      espacio_fv = Espacio.create :nombre => "Fuentes de verificación", :definicion_espacio_proyecto => true, :fuente_verificacion => true
    end
  end

  def self.down
    (Espacio.find_by_nombre_and_definicion_espacio_proyecto "Gastos", true).destroy
    (Espacio.find_by_nombre_and_definicion_espacio_proyecto "Fuentes de verificación", true).destroy
    remove_column :espacio, :fuente_verificacion
    remove_column :espacio, :gasto    
  end
end
