class CreateValoresIntermediosActividad < ActiveRecord::Migration
  def self.up
    create_table :valor_intermedio_x_actividad do |t|
      t.integer :actividad_x_etapa_id
      t.date :fecha
      t.decimal :porcentaje, :precision => 5, :scale => 4
      t.boolean :realizada, :default => false
      t.string :comentario
      t.integer :usuario_id

      t.timestamps
    end

    # Recorremos todas las actividades por etapa
    ActividadXEtapa.all.each do |axe|
      # Y si estan realizadas, generamos el cumplimiento al 100%
      if axe.realizada
        uxp = axe.actividad.proyecto.usuario_x_proyecto.first(:conditions => {:rol => "coordinador"})
        ValorIntermedioXActividad.create(:actividad_x_etapa_id => axe.id, :porcentaje => 1, :realizada => true, :fecha => axe.updated_at.to_date, :usuario_id => uxp ? uxp.usuario_id : nil)
      end 
    end

    # Eliminamos la columnas sobrantes de actividad_x_etapa
    remove_column :actividad_x_etapa, :realizada
  end

  def self.down
    add_column :actividad_x_etapa, :realizada, :boolean, :default => false

    # Restauramos los valores de las actividades
    ActividadXEtapa.all.each do |axe|
      vixa = ValorIntermedioXActividad.last(:order => ["fecha"], :conditions => {:actividad_x_etapa_id => axe.id})
      if vixa
        axe.realizada = vixa.realizada
        axe.save
      end
    end

    drop_table :valor_intermedio_x_actividad
  end
end
